# Contributing

Contributions are welcome. We accept pull requests on [GitHub](https://github.com/rdomenzain/cfdi33-utils).


## Team members

* [Ricardo Domenzain M.](https://github.com/rdomenzain) - original author and main maintainer

## Communication Channels

You can find help and discussion in the following places:

* GitHub Issues: <https://github.com/rdomenzain/cfdi33-utils/issues>

## Reporting Bugs

Bugs are tracked in our project's [issue tracker](https://github.com/rdomenzain/cfdi33-utils/issues).

When submitting a bug report, please include enough information for us to reproduce the bug.
A good bug report includes the following sections:

* Expected outcome
* Actual outcome
* Steps to reproduce, including sample code
* Any other information that will help us debug and reproduce the issue, including stack traces, system/environment information, and screenshots

**Please do not include passwords or any personally identifiable information in your bug report and sample code.**

## Fixing Bugs

We welcome pull requests to fix bugs!

If you see a bug report that you'd like to fix, please feel free to do so.
Following the directions and guidelines described in the "Adding New Features"
section below, you may create bugfix branches and send us pull requests.

## Adding New Features

If you have an idea for a new feature, it's a good idea to check out our
[issues](https://github.com/rdomenzain/cfdi33-utils/issues) or active
[pull requests](https://github.com/rdomenzain/cfdi33-utils/pulls)
first to see if the feature is already being worked on.
If not, feel free to submit an issue first, asking whether the feature is beneficial to the project.
This will save you from doing a lot of development work only to have your feature rejected.
We don't enjoy rejecting your hard work, but some features just don't fit with the goals of the project.

## External resources

To make tests run fast and due some external resources from SAT are sometimes unavailable
I had decide to put those resources on `test/_files/external-resources`. If you want it,
remove that folder and perform the tests. If external resources are available then the
path will be created and your tests will take a little more to run the first time.